<template>
  <q-toolbar class="bg-primary text-white raised">
    <q-toolbar-title role="heading" aria-level="2">
      Networks
    </q-toolbar-title>
  </q-toolbar>
  <q-card>
    <q-card-section v-if="this.arcroles">
      <q-select :options="arcroles" v-model="current_role" @update:model-value="fetchData()" autofocus></q-select>
    </q-card-section>
  </q-card>

  <q-list bordered class="detail--padding scroll_list" :key="language_switch">
    <template v-if="arcs">
      <q-tree :nodes="arcs" node-key="id" ref="arctree" default-expand-all role="tree" color="primary" no-transition>
        <template v-slot:default-header="row">
          <q-item
            dense clickable @click.stop
            class="full-width"
            role="treeitem"
            :class="{active: current===row.node.id}"
            @click="nodeClicked(row.node)">
            <div class="col-10" v-html="show_label(row.node.linkrole)" v-if="row.node.linkrole"></div>
            <div class="col-10" v-html="show_label(row.node.concept)" v-else-if="row.node.concept"></div>
            <div class="col-id" v-else> {{ row.node.id }}</div>
          </q-item>
        </template>
      </q-tree>
    </template>
    <q-inner-loading :showing="typeof arcs=='undefined'">
      <q-circular-progress
        class="text-blue-grey"
        indeterminate
        size="50px"
        :thickness="0.22"
        v-if="typeof arcs=='undefined'"></q-circular-progress>
    </q-inner-loading>

  </q-list>

</template>

<script>
import {api} from 'boot/axios'
import SharedMethods from "components/SharedMethods";

export default {
  name: "ArcList",
  created() {
    this.label_nice_role = SharedMethods.label_nice_role
    this.get_label = SharedMethods.get_label
    this.show_label = SharedMethods.show_label
    if (!this.$route.path.endsWith('/arcs')) {
      this.entry_url = true
      let parts = this.$route.path.split('/').reverse()
      this.entry_arcrole = parts[1]
      this.entry_arc = parts[0]
    }
    this.fetchDropdown()
  },
  data() {
    return {
      arcroles: undefined,
      current_role: undefined,
      current: undefined,
      search_value: '',
      language_switch: undefined,
      arcs: undefined,
      entry_url: false,
      entry_arcrole: undefined,
      entry_arc: undefined,
    }
  },
  props: {
    dts_name: String,
    nt_version: String,
  },
  methods: {
    fetchData: function () {
      if (this.current_role) {
        this.arcs = undefined
        api
          .get("/dts/" + this.dts_name + "/arcs/" + this.current_role.value,
            {params: {nt_version: this.nt_version}})
          .then(response => {
            this.arcs = response.data.children;
            if (!this.entry_url) {
              let first_concept = this.arcs.find(item => item.concept);
              if (!first_concept && this.arcs[0]) {
                first_concept = this.arcs[0].children.find(item => item.concept)
              }
              if (first_concept) {
                this.$router.push({
                  name: 'arc_detail',
                  replace: true,
                  params: {arcrole: this.current_role.value, object_id: first_concept.concept.id}
                })
                this.current = first_concept.id
              }
            } else {
              this.$router.push({
                name: 'arc_detail',
                replace: true,
                params: {arcrole: this.current_role.value, object_id: this.entry_arc}
              })
              this.current = this.entry_arc
            }
            if (this.$refs.arctree) {
              this.$nextTick(() => {
                this.$refs.arctree.expandAll();
              })
            }
            this.entry_url = false
          })
      }
    },
    fetchDropdown: function () {
      api
        .get("/dts/" + this.dts_name + "/arcroles", {params: {nt_version: this.nt_version}})
        .then(response => {
          this.arcroles = response.data;
          if (this.arcroles) {
            if (this.entry_url && this.entry_arcrole) {
              for (let role of this.arcroles) {
                if (role.value === this.entry_arcrole) {
                  this.current_role = role
                }
              }
            } else {
              this.current_role = this.arcroles[0]
            }
            this.fetchData()
          }
        })
    },
    scroll_to_active: function () {
      let activelist = document.getElementsByClassName('active')
      if (activelist.length) {
        let el = activelist[0]
        let offset = el.getBoundingClientRect().top - window.scrollY - 100
        if (offset > window.innerHeight || offset < 0) {
          this.$nextTick(() => {
              el.scrollIntoView(true)
            }
          )
        }
      }
    },
    nodeClicked: function (node) {
      this.current = node.id
      if (node.concept && node.concept.id) {
        this.$router.push({name: 'arc_detail', params: {arcrole: this.current_role.value, object_id: node.concept.id}})
      }
    }
  },
  watch: {
    "$route.query.lang": function () {
      this.language_switch = this.$route.query.lang
    }
  }
}
</script>


<style scoped lang="scss">
.active {
  background: $primary;
  color: white;
  opacity: 0.9;
}

.scroll_list {
  overflow-y: auto;
  height: calc(100vh - 290px);
}

.q-list--dense > .q-item, .q-item--dense {
  padding: 0 10px !important;
}


</style>
